#include <IRremote.h>

const int irReceiverPin = 13;
const int red = 5;
const int green = 4;
const int blue = 3;
long duration;
long inches;
int distance;
IRrecv irrecv(irReceiverPin);
decode_results results;
int pir = A0;
int buzzer = 2;
int trig = A1;
int echo = A2;
int a = 9;
int b = 7;
int c = 10;
int d = 11;
int e = 12;
int f = 8;
int g = 6;
int x = 0;

void setup() {
  pinMode(red, OUTPUT);
  pinMode(blue, OUTPUT);
  pinMode(green, OUTPUT);
  pinMode (pir, INPUT);
  pinMode (buzzer, OUTPUT);
  Serial.begin(9600);
  irrecv.enableIRIn();
  pinMode (a, OUTPUT);
  pinMode (b, OUTPUT);
  pinMode (c, OUTPUT);
  pinMode (d, OUTPUT);
  pinMode (e, OUTPUT);
  pinMode (f, OUTPUT);
  pinMode (g, OUTPUT);
  pinMode (echo, INPUT);
  pinMode (trig, OUTPUT);
}

void setColour (int r, int g, int b) {
  r = 255 - r;
  g = 255 - g;
  b = 255 - b;
  analogWrite(red, r);
  analogWrite(green, g);
  analogWrite(blue, b);
}

void countdown () {
  Serial.println ("The alarm system is turning on, please wait...");
  setColour (180, 255, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, HIGH);
  digitalWrite (c, LOW);
  digitalWrite (d, LOW);
  digitalWrite (e, HIGH);
  digitalWrite (f, LOW);
  digitalWrite (g, LOW);
  delay (1000);

  setColour (0, 0, 0);
  digitalWrite (a, HIGH);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, HIGH);
  digitalWrite (e, HIGH);
  digitalWrite (f, LOW);
  digitalWrite (g, LOW);
  delay (1000);

  setColour (180, 255, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, LOW);
  digitalWrite (e, HIGH);
  digitalWrite (f, HIGH);
  digitalWrite (g, LOW);
  delay (1000);

  setColour (0, 0, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, LOW);
  digitalWrite (c, HIGH);
  digitalWrite (d, LOW);
  digitalWrite (e, LOW);
  digitalWrite (f, HIGH);
  digitalWrite (g, LOW);
  delay (1000);

  setColour (180, 255, 0);
  digitalWrite (a, HIGH);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, HIGH);
  digitalWrite (e, HIGH);
  digitalWrite (f, HIGH);
  digitalWrite (g, HIGH);
  delay (1000);

  setColour (0, 0, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, LOW);
  digitalWrite (e, LOW);
  digitalWrite (f, LOW);
  digitalWrite (g, HIGH);
  delay (1000);
  setColour (180, 255, 0);
  delay(100);
  setColour (0, 0, 0);
}
void away () {
  Serial.println ("The system is armed, have a nice day. If an intruder is detected the default number to call is 911.");
  setColour (255, 0, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, HIGH);
  digitalWrite (e, LOW);
  digitalWrite (f, LOW);
  digitalWrite (g, LOW);
  if (digitalRead(pir) == 1) {
    digitalWrite (buzzer, HIGH);
    setColour (180, 255, 255);
    Serial.println ("Intruder Detected! Calling 911!");
  }
  
}
void night () {
  Serial.println ("The system is armed. Opening doors will set off the alarm. If a door is opened the default number to call is 911.");
  setColour (255, 0, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, HIGH);
  digitalWrite (e, LOW);
  digitalWrite (f, LOW);
  digitalWrite (g, LOW);
}

void sensor () {
  digitalWrite (trig, LOW);
  delayMicroseconds(2);
  digitalWrite (trig, HIGH);
  delayMicroseconds(10);
  digitalWrite (trig, LOW);
  duration = pulseIn (echo, HIGH);
  distance = (duration / 2) / 74; //inches
  inches = duration / 74 / 2;
}

void disarmed () {
  Serial.println ("The system is disarmed.");
  setColour (0, 255, 0);
  digitalWrite (a, LOW);
  digitalWrite (b, LOW);
  digitalWrite (c, LOW);
  digitalWrite (d, LOW);
  digitalWrite (e, LOW);
  digitalWrite (f, LOW);
  digitalWrite (g, LOW);
  delay (300);
  digitalWrite (a, HIGH);
  digitalWrite (b, HIGH);
  digitalWrite (c, HIGH);
  digitalWrite (d, HIGH);
  digitalWrite (e, HIGH);
  digitalWrite (f, HIGH);
  digitalWrite (g, HIGH);
  delay (300);
}

void error () {
  Serial.println ("System Error: Unknown Button Pressed.");
  digitalWrite (a, LOW);
  digitalWrite (b, HIGH);
  digitalWrite (c, HIGH);
  digitalWrite (d, LOW);
  digitalWrite (e, LOW);
  digitalWrite (f, LOW);
  digitalWrite (g, LOW);
  setColour (255, 0, 0);
}

void off () {
  Serial.println ("The system has been turned off until further notice.");
  setColour (0, 0, 0);
  digitalWrite (buzzer, LOW);
  digitalWrite (a, HIGH);
  digitalWrite (b, HIGH);
  digitalWrite (c, HIGH);
  digitalWrite (d, HIGH);
  digitalWrite (e, HIGH);
  digitalWrite (f, HIGH);
  digitalWrite (g, HIGH);
}
void loop() {
  digitalWrite (trig, LOW);
  delayMicroseconds(2);
  digitalWrite (trig, HIGH);
  delayMicroseconds(10);
  digitalWrite (trig, LOW);
  duration = pulseIn (echo, HIGH);
  distance = (duration / 2) / 74; //inches
  inches = duration / 74 / 2;
  Serial.println (inches);
  
  if (irrecv.decode(&results))
  {
    irrecv.resume();
  }
  delay(600);
  if (results.value == 0) { //ready
    setColour (0, 255, 0);
  }
  if (results.value == 551494365) { //away
    setColour (0, 0, 0);
    countdown();
    if (irrecv.decode(&results))
  {
    irrecv.resume();
  }
  if(results.value == 4294967295){ //arm
    away();
      if (digitalRead(pir) == 1) {
    digitalWrite (buzzer, HIGH);
    setColour (180, 255, 255);
    Serial.println ("Intruder Detected! Calling 911!");
  }
   while (results.value == 4294967295){
  digitalWrite (trig, LOW);
  delayMicroseconds(2);
  digitalWrite (trig, HIGH);
  delayMicroseconds(10);
  digitalWrite (trig, LOW);
  duration = pulseIn (echo, HIGH);
  distance = (duration / 2) / 74; //inches
  inches = duration / 74 / 2;
  delay (100);
    if (inches >= 3) {
     digitalWrite (buzzer, HIGH);
     break;
  }
  }
  }
  }
  if (results.value == 551531595) { //night
    countdown();
     if (irrecv.decode(&results))
  {
    irrecv.resume();
  }
      if(results.value == 4294967295){ //arm
    night();
    
   while (results.value == 4294967295){ 
  digitalWrite (trig, LOW);
  delayMicroseconds(2);
  digitalWrite (trig, HIGH);
  delayMicroseconds(10);
  digitalWrite (trig, LOW);
  duration = pulseIn (echo, HIGH);
  distance = (duration / 2) / 74; //inches
  inches = duration / 74 / 2;
  delay (100);
     if (inches >= 3) {
     digitalWrite (buzzer, HIGH);
     break;
  }
  }
  }
  }
  if (results.value == 551547915) { //disarm
    setColour (0, 0, 0);
    digitalWrite (buzzer, LOW);
    disarmed ();
  }
  if (results.value == 551489775) { //turn off
    off ();
  }
  if (results.value < 551547915 && results.value > 551489775 && results.value > 551531595 && results.value > 551494365 || results.value > 551547915 && results.value < 551494365 && results.value < 551531595 || results.value < 4294967295 && results.value < 551494365 && results.value > 551531595 && results.value > 551531595 || results.value > 551547915 && results.value > 551494365 && results.value > 551531595 && results.value > 551531595|| results.value < 551547915 && results.value > 551494365 && results.value > 551531595){ //error mode
    setColour (0, 0, 0);
    error ();
  }
}
